from discord import User
from discord.ext import commands


class AdminCog(commands.Cog):
    """
    Guild admin functions

    Used to manage guilds
    """

    def __init__(self, bot):
        self.bot = bot

    @commands.command(name="ban")
    @commands.has_permissions(administrator=True)
    async def _ban(self, ctx, user: User = None, reason=None):
        if not user or user == ctx.message.author:
            await ctx.send("You cannot ban yourself.")
        if not reason:
            reason = (
                "Mr. Stark is displeased with your presence. Please leave."
            )
        await user.send(
            f"You have been banned from Stark Industries. Reason:\n{reason}"
        )
        await ctx.guild.ban(user, reason=reason)
        await ctx.send(
            f"{user.name} has been banned from Stark Industries."
            + f"Reason:\n{reason}"
        )

    @commands.Cog.listener()
    async def on_command_error(self, ctx, error):
        if isinstance(error, commands.errors.MissingPermissions):
            await ctx.send("I'm afraid I can't let you do that.")


def setup(bot):
    bot.add_cog(AdminCog(bot))
